
from basics import *

class Spec:
   def __init__(self,mask,maskkey,disp,dispkey,target,lamp,flat,root):
      self.mask = mask.lower()
      self.maskkey = maskkey.lower()
      self.disp = disp.lower()
      self.dispkey = dispkey.lower()
      if target: self.target = target.lower()
      else: self.target = None
      if lamp: self.lamp = lamp.lower()
      else: self.lamp = None
      if flat: self.flat = flat.lower()
      else: self.flat = None
      if root: self.root = root.lower()
      else: self.root = mask.lower()

def ParseHeader(l):
   h = l[1:-2].lower()
   k = map(eval,split(h))
   return k

def ParseListing(S,H,L):
   D = {}
   for w in H: D[w] = []
   D["usemask"] = []
   D["usedisp"] = []
   D["uselamp"] = []
   D["useflat"] = []
   D["usetarg"] = []
   D["root"] = []
   D["name"] = []
   for l in L:
       k = split(l.lower())
       v = []
       p = []
       a = 0
       for j in range(len(k)):
         if not (k[j].count("'") % 2) and not a:
             v.append(k[j])
             p.append( k[j].count("'"))
         else:
            if not a:
               v.append(k[j])
               a = 1
            else:
               v[-1]=join([v[-1],k[j]])
               a = (a + k[j].count("'")) % 2
       usemask = 0
       usedisp = 0
       uselamp = 0
       useflat = 0
       usetarg = 0
       for j in range(len(v)):
         if v[j].count("'") and not v[j].count("'") % 2: v[j] = eval(v[j])
         if H[j] == "exptime": v[j] = float(v[j])
         if H[j] == "naxis1": v[j] = int(v[j])
         if H[j] == "naxis2": v[j] = int(v[j])
         if H[j] == S.maskkey and find(v[j],S.mask)+1: usemask = 1
         if H[j] == S.dispkey and find(v[j],S.disp)+1: usedisp = 1
         if H[j] == "object":
            if S.lamp: uselamp = find(v[j],S.lamp)+1
            if S.flat: useflat = find(v[j],S.flat)+1
            if S.target: usetarg = find(v[j],S.target)+1
         D[H[j]].append(v[j])
       D["usemask"].append(usemask)
       D["usedisp"].append(usedisp)
       D["uselamp"].append(uselamp)
       D["useflat"].append(useflat)
       D["usetarg"].append(usetarg)
       D["root"].append([])
       D["name"].append([])
   return D

def ReadListing(S,f):
   F = open(f,"r")
   L = F.readlines()
   H = ParseHeader(L[1])
   D = ParseListing(S,H,L[3:])
   F.close()
   useframes = equal(D["usemask"],1)* equal(D["usedisp"],1)
   lampframes = useframes * greater(D["uselamp"],0)
   flatframes = useframes * greater(D["useflat"],0)
   dataframes = useframes-lampframes-flatframes
   if S.target:
      dataframes = dataframes * greater(D["usetarg"],0)
   D["useframes"] = lampframes+flatframes+dataframes
   D["lampframes"] = lampframes
   D["flatframes"] = flatframes
   D["dataframes"] = dataframes
   useframes = D["useframes"]
   D["num"] = add.accumulate(D["dataframes"])*D["dataframes"]
   D["num"] += add.accumulate(D["lampframes"])*D["lampframes"]
   D["num"] += add.accumulate(D["flatframes"])*D["flatframes"]
   for j in nonzero( D["dataframes"]):
      D["root"][j] = join([S.root,"spec",str(D["num"][j])],"")
      D["name"][j] = join([S.root,"spec",str(D["num"][j])],"")
   for j in nonzero( D["lampframes"]):
      D["root"][j] = join([S.root,"lamp",str(D["num"][j])],"")
      D["name"][j] = join([S.root,"lamp",str(D["num"][j])],"")
   for j in nonzero( D["flatframes"]):
      D["root"][j] = join([S.root,"flat",str(D["num"][j])],"")
      D["name"][j] = join([S.root,"flat",str(D["num"][j])],"")
   return D

