
from os import remove
import tempfile
from FITS import *
from basics import *
from IM import *

tempfile.tempdir=""

def pastecen(x,m,n=0,c=0):
  m = int(m); n = int(n)
  if len(x.shape) == 1:
     xo = (m-x.shape[0])/2
     y=c*ones( (m), x.typecode()).astype(x.typecode())
     y[xo:xo:x.shape[0]] = x
  elif len(x.shape) == 2:
     xo = (m-x.shape[1])/2
     yo = (n-x.shape[0])/2
     y=c*ones( (n,m), x.typecode()).astype(x.typecode())
     y[yo:yo+x.shape[0], xo:xo+x.shape[1]] = x
  return y

def Get_CvPoints(i,x,y):
    x, y = compress(i.flat,[x.flat, y.flat],1) + 0.5
    return [OpenCV.CvPoint2D32f(x[j],y[j]) for j in range(len(x))]

def ImageMoments(image):
   I = np2cv(image)
   ms = apply(OpenCV.CvMoments,18*[0.])
   OpenCV.Moments(I,ms,0)
   del I
   return ms

def HuMoments(ms):
   hs = apply(OpenCV.CvHuMoments,7*[0.])
   OpenCV.GetHuMoments(ms,hs)
   return hs

def np2cv(x):
     nx, ny = x.shape[1], x.shape[0]
     ns = Numeric_ToString(x)
     tys = [IPL_DEPTH_32F,IPL_DEPTH_8U]
     tyc = ["f","b"]
     m = tys[tyc.index(x.typecode())]
     ip = IplImage_FromString(ns, m, nx, ny, 1)
     del ns
     return ip

def PyrDecomp(d,lev=None,w=None,start=0,verb=0):
   d = d.astype(Float32)
   od = (1*d).astype(Float32)
   rx, ry = d.shape[1], d.shape[0]
   ox, oy = d.shape[1], d.shape[0]

   if ox > 1: m2=int(log2(ox-1))+1
   else: m2 = 0
   if oy > 1: n2=int(log2(oy-1))+1
   else: n2 = 0

   if lev: lev=min([lev,min(m2,n2)-1])
   else: lev=min(m2,n2)-1
#   n2 = pow(2,n2)
#   m2 = pow(2,m2)
   m2,n2 = ox, oy

#   if d.shape != (n2,m2):
#      d = pastecen(d,m2,n2,mean(d.flat)).astype(Float32)
#      if w: w = pastecen(w,m2,n2,mean(w.flat)).astype(Float32)
   o = d
   ox, oy = d.shape[1], d.shape[0]
   xo = (ox-rx)/2
   yo = (oy-ry)/2

   a=[]

   for i in range(lev):

     sx, sy = d.shape[1]/2, d.shape[0]/2
     if (2*sy,2*sx) != d.shape:
       if verb: print "Pasting"
       if 2*sy != d.shape[0]: usy = 2*sy + 2
       else: usy = 2*sy
       if 2*sx != d.shape[1]: usx = 2*sx + 2
       else: usx = 2*sx
       t = zeros((usy,usx),Float32)
       t[:d.shape[0],:d.shape[1]] = d
       d = t
       sx, sy = d.shape[1]/2, d.shape[0]/2

     ip = np2cv(d)
     sp = New_IplImage(IPL_DEPTH_32F, sx, sy, 1)
     OpenCV.PyrDown(ip,sp)
     ss = IplImage_ToString(sp)
     s = Numeric_FromString(ss, Float32, sp.width, sp.height, 1)
     if verb: print i+1, s.shape

     sx, sy = s.shape[1], s.shape[0]
     ox, oy = sx*2, sy*2
     ip = np2cv(s)
     sp = New_IplImage(IPL_DEPTH_32F, ox, oy, 1)
     OpenCV.PyrUp(ip,sp)
     ss = IplImage_ToString(sp)
     f = Numeric_FromString(ss, Float32, sp.width, sp.height, 1)

     for j in range(i):
        sx, sy = f.shape[1], f.shape[0]
        ox, oy = sx*2, sy*2
        ip = np2cv(f)
        sp = New_IplImage(IPL_DEPTH_32F, ox, oy, 1)
        OpenCV.PyrUp(ip,sp)
        ss = IplImage_ToString(sp)
        f = Numeric_FromString(ss, Float32, sp.width, sp.height, 1)
     if i+1 > start: a.append( f[:ry,:rx])
#     if i+1 > start: a.append( f[yo:yo+ry,xo:xo+rx])
     d = s
     if w: w = t

   a = [od]+a
   a = asarray(a,Float32)
   a = (a[:-1] - a[1:]).astype(Float32)
   a = concatenate([a, [ (od-sum(a)).astype(Float32)]])
   if verb: print "returning"
   return a

def oldPyrLevel(d,lev,verb=0):
   d = d.astype(Float32)
   rx, ry = d.shape[1], d.shape[0]
   ox, oy = d.shape[1], d.shape[0]

   if ox > 1: m2=int(log2(ox-1))+1
   else: m2 = 0
   if oy > 1: n2=int(log2(oy-1))+1
   else: n2 = 0

   lev=min([lev,min(m2,n2)-1])
   n2 = pow(2,n2)
   m2 = pow(2,m2)

   if d.shape != (n2,m2):
      d = pastecen(d,m2,n2,mean(d.flat)).astype(Float32)
   ox, oy = d.shape[1], d.shape[0]
   xo = (ox-rx)/2
   yo = (oy-ry)/2

   for i in range(lev):

     sx, sy = d.shape[1]/2, d.shape[0]/2
     ip = np2cv(d)
     sp = New_IplImage(IPL_DEPTH_32F, sx, sy, 1)
     OpenCV.PyrDown(ip,sp)
     ss = IplImage_ToString(sp)
     s = Numeric_FromString(ss, Float32, sp.width, sp.height, 1)
     if verb: print i+1, s.shape

     sx, sy = s.shape[1], s.shape[0]
     ox, oy = sx*2, sy*2
     ip = np2cv(s)
     sp = New_IplImage(IPL_DEPTH_32F, ox, oy, 1)
     OpenCV.PyrUp(ip,sp)
     ss = IplImage_ToString(sp)
     f = Numeric_FromString(ss, Float32, sp.width, sp.height, 1)

     for j in range(i):
        sx, sy = f.shape[1], f.shape[0]
        ox, oy = sx*2, sy*2
        ip = np2cv(f)
        sp = New_IplImage(IPL_DEPTH_32F, ox, oy, 1)
        OpenCV.PyrUp(ip,sp)
        ss = IplImage_ToString(sp)
        f = Numeric_FromString(ss, Float32, sp.width, sp.height, 1)
     d = s

   return f[yo:yo+ry,xo:xo+rx]

def PyrLevel(d,lev,verb=0): return PyrDown(d,lev,verb=verb)

def PyrDown(d,lev,verb=0):
   d = d.astype(Float32)
   ox, oy = d.shape[1], d.shape[0]

   for i in range(lev):

     sx, sy = d.shape[1]/2, d.shape[0]/2
     if (2*sy,2*sx) != d.shape:
       if verb: print "Pasting"
       if 2*sy != d.shape[0]: usy = 2*sy + 2
       else: usy = 2*sy
       if 2*sx != d.shape[1]: usx = 2*sx + 2
       else: usx = 2*sx
       t = zeros((usy,usx),Float32)
       t[:d.shape[0],:d.shape[1]] = d
       d = t
       sx, sy = d.shape[1]/2, d.shape[0]/2
     ip = np2cv(d)
     sp = New_IplImage(IPL_DEPTH_32F, sx, sy, 1)
     OpenCV.PyrDown(ip,sp)
     ss = IplImage_ToString(sp)
     d = Numeric_FromString(ss, Float32, sp.width, sp.height, 1)
     del ss, sp
     if verb: print i+1, d.shape

   for i in range(lev):
     sx, sy = d.shape[1], d.shape[0]
     ip = np2cv(d)
     sp = New_IplImage(IPL_DEPTH_32F, sx*2, sy*2, 1)
     OpenCV.PyrUp(ip,sp)
     ss = IplImage_ToString(sp)
     d = Numeric_FromString(ss, Float32, sp.width, sp.height, 1)
     del sp, ss

   return d[:oy,:ox]

def tempPyrDown(x,lev,verb=0):
    y = x.typecode()
    t = "/tmp/pyr"+tempfile.mktemp()+".fits"
    t2 = "/tmp/pyr"+tempfile.mktemp()+".fits"
    qdump(t,x.astype(Float32),verb=0)
    verbex("efits "+t+" 'PyrDown(i1,lev="+str(lev)+",verb="+str(verb)+")' "+t2)
    x = qread(t2)
    remove(t)
    remove(t2)
    return x

