#!/usr/bin/env python

from FITS import *
from MLab import *
from masks import *
from basics import *
from sys import *

import Image as P
import ImageDraw as D
import ImageFont as F
import ImageFile
import PSDraw as PS

def epsfbegin(filename,bbox):
  fp=open(filename,"w")
  fp.write("%!PS-Adobe-3.0 EPSF-3.0\n")
  fp.write("%%Creator: PIL 0.1 EpsEncode\n")
  fp.write("%%%%BoundingBox: %d %d %d %d\n" % bbox)
  fp.write("%%Pages: 1\n")
  fp.write("%%EndComments\n")
  fp.write("%%Page: 1 1\n")
  fp.write(PS.EDROFF_PS)
  fp.write(PS.VDI_PS)
  fp.write("/SRGB { setrgbcolor } bind def\n")
  fp.write("/SLW { setlinewidth } bind def\n")
  fp.write("%%EndProlog\n")
  return fp

def imdump(fp,scales,im):
    if im.mode == "L": operator = (8, 1, "image")
    elif im.mode == "RGB": operator = (8, 3, "false 3 colorimage")
    elif im.mode == "CMYK": operator = (8, 4, "false 4 colorimage")
    else: raise ValueError, "image mode is not supported"

    fp.write("%%ImageData: %d %d " % im.size)
    fp.write("%d %d 0 1 1 \"%s\"\n" % operator)
    fp.write("gsave\n")
    fp.write("10 dict begin\n")
    fp.write("/buf %d string def\n" % (im.size[0] * operator[1]))
    fp.write("%d %d scale\n" % scales)
    fp.write("%d %d 8\n" % im.size) # <= bits
    fp.write("[%d 0 0 -%d 0 %d]\n" % (im.size[0], im.size[1], im.size[1]))
    fp.write("{ currentfile buf readhexstring pop } bind\n")
    fp.write("%s\n" % operator[2])

    ImageFile._save(im, fp, [("eps", (0,0)+im.size, 0, None)])

    fp.write("\n%%%%EndBinary\n")
    fp.write("grestore end\n")
    fp.flush()

def drawline(psfile,p1, p2, magnif=1.0, lw=0.2):
   xy=(magnif*p1[0],magnif*p1[1], magnif*p2[0],magnif*p2[1])
   psfile.write("1.0 1.0 1.0 SRGB\n")
   psfile.write(str(lw)+" SLW\n")
   psfile.write("%f %f %f %f Vl\n" % xy)

def psguts(p):
   pscom = open(p,"r")
   pscoms = pscom.readlines()
   psplits = [split(p) for p in pscoms]
   first = nonzero([(p == ["%%BeginProlog"]) for p in psplits])[0]
   last = nonzero([(p == ["%%PageTrailer"]) for p in psplits])[0]
   pscom.close()
   return {'lines':pscoms, 'first':first, 'last':last}

def pscat(newps,psfiles):
   n = open(newps,"w")
   pf = [psguts(p) for p in psfiles]
   n.writelines(pf[0]['lines'][:pf[0]['first']])
   for pl in pf:
      n.writelines(pl['lines'][pl['first']:pl['last']])
      n.write("gsave grestore\n")
   for l in pf[-1]['lines'][pf[-1]['last']:]:
      try:
         if split(l)[0] == "%%Pages:": l = join([split(l)[0],str(len(psfiles)),"\n"])
      except: pass
      n.write(l)
   n.close()


