
from os import environ
import flwt as L
from basics import *
from Numeric import *
from MLab import flipud,fliplr,squeeze
from re import sub

gt = greater
ge = greater_equal
lt = less
le = less_equal

#
# To do:  What is the convolution kernel for Beta smearing?
# Check:  Do the beta convolution, then do a wavelet transform
#         and do inverse convolution in the individual wavelet
#         passes. It is likely that this will be fruitless....
#

LPARAMS=None

def log2(x): return log(x)/log(2)

def init2d(x,nn=2,nt=2,lev=None,verb=0):
  if len(x.shape) == 1: n,m=1,x.shape[0]
  else: n,m=x.shape
  if m > 1: m2=int(log2( (m-1)/(max((nn,nt))-1)))
  else: m2 = 0
  if n > 1: n2=int(log2( (n-1)/(max((nn,nt))-1)))
  else: n2 = 0
  if not lev: lev=max(m2,n2)
  L.GetDual(m,n,nn,nt,verb,lev)
  L.GetReal(m,n,nn,nt,verb,lev)
  L.__dict__["LPARAMS"]={ "NN":nn, "NT":nt, "M,N":(m,n), "L":lev}

def flwt2d(d,nn=None,nt=None,lev=None):
  x = d.astype(Float64)
  if not L.__dict__.has_key("LPARAMS") or (nn != None and nt != None and lev != None): init2d(x,nn,nt,lev)
  nn=L.LPARAMS["NN"]
  nt=L.LPARAMS["NT"]
  m,n=L.LPARAMS["M,N"]
  lev=L.LPARAMS["L"]
  L.FLWT2D(x,m,n,nn,nt,lev,0)
  return x.astype(d.typecode())

def inverse_flwt2d(d,nn=None,nt=None,lev=None):
  x = d.astype(Float64)
  if not L.__dict__.has_key("LPARAMS") or (nn != None and nt != None and lev != None): init2d(x,nn,nt,lev)
  nn=L.LPARAMS["NN"]
  nt=L.LPARAMS["NT"]
  m,n=L.LPARAMS["M,N"]
  lev=L.LPARAMS["L"]
  L.FLWT2D(x,m,n,nn,nt,lev,1)
  return x.astype(d.typecode())

def frmall(d,nn=None,nt=None,lev=None):
  x = d.astype(Float64)
  if not L.__dict__.has_key("LPARAMS") or (nn != None and nt != None and lev != None): init2d(x,nn,nt,lev)
  if not L.__dict__.has_key("LPARAMS") or (nn != None and nt != None): init2d(x,nn,nt)
  nn=L.LPARAMS["NN"]
  nt=L.LPARAMS["NT"]
  m,n=L.LPARAMS["M,N"]
  lev=L.LPARAMS["L"]
  L.FLWTChangeFormat(x,n,m,nn,nt,lev,1)
  return x.astype(d.typecode())

def tomall(d,nn=None,nt=None):
  x = d.astype(Float64)
  if not L.__dict__.has_key("LPARAMS") or (nn != None and nt != None): init2d(x,nn,nt)
  nn=L.LPARAMS["NN"]
  nt=L.LPARAMS["NT"]
  m,n=L.LPARAMS["M,N"]
  lev=L.LPARAMS["L"]
  L.FLWTChangeFormat(x,n,m,nn,nt,lev,0)
  return x.astype(d.typecode())

def beta(x,b,nn=None,nt=None):
   jar=getjar2d(x,nn,nt,noxy=1)
   return power(b,jar)

def newgetjar2d(x,nn=None,nt=None,lev=None,cx=1.0,cy=1.0,cd=1.0,verb=0,noxy=1):
  if not L.__dict__.has_key("LPARAMS") or (nn != None and nt != None and lev != None): init2d(x,nn,nt,lev)
  nn=L.LPARAMS["NN"]; nt=L.LPARAMS["NT"]
  m,n=L.LPARAMS["M,N"]; lev=L.LPARAMS["L"]
  lengthsX = [-m]; lengthsY = [-n]
  for l in range(lev):
     lengthsX.append( lengthsX[-1]/2 )
     lengthsY.append( lengthsY[-1]/2 )
  lengthsX.append( 0); lengthsY.append( 0)
  if verb: print lengthsX
  if verb: print lengthsY
  xy=indices(x.shape,Int16)
  urx = -asarray(lengthsX)[:-2][::-1]/2
  urx = urx + equal(urx,0)
  ury = -asarray(lengthsY)[:-2][::-1]/2
  ury = ury + equal(ury,0)
  if verb: print urx
  if verb: print ury
  if verb: print "Making J array"
  jar = zeros(x.shape,Int16)
  for uj in range(len(urx)):
     ue = urx[uj]
     uf = ury[uj]
     if verb: print "doing",ue,uf
     jar = (jar + not_equal(remainder(xy[0],uf)+remainder(xy[1],ue),0)).astype(Int16)
  xyr = zeros(x.shape,Int16)
  if not noxy:
     if verb: print "ToMallot!"
     jar=tomall(jar,nn,nt)
     ir = arange(len(lengthsX)-2)+1
     if verb: print "Making XYD array"
     for ie in range(len(ir)):
       if verb: print "Making XYD array",ie
       ue = ir[-(ie+1)]
       lx = -lengthsX[(ie+1)]; ly = -lengthsY[(ie+1)]
       ljar = equal(jar,ue)
       xyd = (3*ljar * greater_equal(xy[0],ly) * greater_equal(xy[1],lx)).astype(Int16)
       xyy = (2*ljar * greater_equal(xy[0],ly) * less(xy[1],ly)).astype(Int16)
       xyx = (1*ljar * greater_equal(xy[1],lx) * less(xy[0],lx)).astype(Int16)
       xyr = (xyr + xyd + xyx + xyy).astype(Int16)
     if verb: print "UnMallot!"
     jar=frmall(jar,nn,nt).astype(Int16)
     xyr=frmall(xyr,nn,nt).astype(Int16)
  if noxy: return asarray(jar)
  else: return asarray([jar,xyr])

def oldgetjar2d(x,nn=None,nt=None,lev=None,cx=1.0,cy=1.0,cd=1.0,verb=0):
  if not L.__dict__.has_key("LPARAMS") or (nn != None and nt != None and lev != None): init2d(x,nn,nt,lev)
  nn=L.LPARAMS["NN"]; nt=L.LPARAMS["NT"]
  m,n=L.LPARAMS["M,N"]; lev=L.LPARAMS["L"]
  lengthsX = [-m]; lengthsY = [-n]
  for l in range(lev):
     lengthsX.append( lengthsX[-1]/2 )
     lengthsY.append( lengthsY[-1]/2 )
  lengthsX.append( 0); lengthsY.append( 0)
  xy=indices(x.shape,Int16)
  ur = power(2,arange(len(lengthsX)-2)+1)
  jar=sum(map(lambda ue: not_equal(remainder(xy[0],ue)+remainder(xy[1],ue),0), ur))
  jar=tomall(jar,nn,nt)
  xyr = zeros((n,m),Int16)
  for l in range(len(lengthsX)-1):
     m0 = -lengthsX[l+1]; m1 = -lengthsX[l]
     n0 = -lengthsY[l+1]; n1 = -lengthsY[l]
     if verb: print l,lev,m0,m1,n0,n1
     my = m1-m0; ny = n1-n0
     cox = (lev-l) * cx
     coy = (lev-l) * cy
     cod = (lev-l) * cd
     jar[m0:m1,n0:n1] = (cod*ones( (my,ny))).astype(Int16)
     jar[:m0,n0:n1]   = (coy*ones( (m0,ny))).astype(Int16)
     jar[m0:m1,:n0]   = (cox*ones( (my,n0))).astype(Int16)
     xyr[m0:m1,n0:n1] = (3*ones( (my,ny))).astype(Int16)
     xyr[:m0,n0:n1]   = (2*ones( (m0,ny))).astype(Int16)
     xyr[m0:m1,:n0]   = (1*ones( (my,n0))).astype(Int16)
  jar=frmall(jar.astype(Float64)).astype(Int16)
  xyr=frmall(xyr.astype(Float64)).astype(Int16)
  return asarray([jar,xyr])

getjar2d = oldgetjar2d

def atrous2d(x,nfilt=3,lev=None,slev=0,verb=None,periodic=None,weight=None,ustat=sum):
  x=1.*x
  if ustat != sum: print "that's not quite supported yet!"
  if len(x.shape) != 2: return -1
  n,m=x.shape
  if not lev:
     if m > 1: m2=int(log2(m-1))
     else: m2 = 0
     if n > 1: n2=int(log2(n-1))
     else: n2 = 0
     lev=max(m2,n2)
  if verb: print "Doing",lev,"levels."
  if nfilt == 3: filt = [0.25,0.5,0.25]
  if nfilt == 5: filt = [0.0625,0.25,0.375,0.25,0.0625]
  def filter_mask(fx,fy,nfilt=nfilt,verb=verb):
    if nfilt == 3: filt = [0.25,0.5,0.25]
    if nfilt == 5: filt = [0.0625,0.25,0.375,0.25,0.0625]
    return filt[fx]*filt[fy]
  w = []
  cjj = 1.0*x
  if weight: wcjj = 1.0*weight
  for j in range(slev,lev):
    if verb: print "Doing",j,"level."
    la = arange(n); ka = arange(m)
    fya = arange(nfilt); fxa = arange(nfilt)
    def off(fxy,j=j,nfilt=nfilt): return int(pow(2,j)*(fxy-0.5*float(nfilt-1)))
    loffa = []; koffa = []
    for nf in range(nfilt):
      if periodic:
         l2 = la+off(fya[nf]); k2 = ka+off(fxa[nf])
         loffa.append( l2 - n*greater(l2,n-1))
         koffa.append( k2 - m*greater(k2,m-1))
      else:
         loffa.append( clip( la+off(fya[nf]),0,n-1) )
         koffa.append( clip( ka+off(fxa[nf]),0,m-1) )
    cj = zeros((n,m),Float64)
    if weight: wcj = zeros((n,m),Float64)
    for fy in range(nfilt):
      tcj = take(cjj, loffa[fy], 0)
      if weight: wtcj = take(wcjj, loffa[fy], 0)
      for jn in range(n):
         for fx in range(nfilt):
           cj[jn] = cj[jn] + take(tcj[jn], koffa[fx], 0) * filter_mask(fx,fy)
           if weight: wcj[jn] = wcj[jn] + take(wtcj[jn], koffa[fx], 0) * filter_mask(fx,fy)
    if weight: print min(wcj.flat),max(wcj.flat)
    if weight: cj = divz(cj, wcj)
    if weight: print min(cj.flat),max(cj.flat)
    w.append( (cjj - cj).astype(Float32))
    cjj = 1.0*cj
    if weight: wcjj = 1.0*wcj
  w.append(cj.astype(Float32))
  return asarray(w).astype(Float32)

def atrous1d(x,nfilt=3,lev=None,verb=None,periodic=None):
  x=1.*x
  if len(x.shape) != 1: return -1
  m=x.shape[0]
  if not lev:
     if m > 1: m2=int(log2(m-1))
     else: m2 = 0
     lev=m2
  if verb: print "Doing",lev,"levels."
  def filter_mask(f,nfilt=nfilt,verb=verb):
    if nfilt == 3: filt = [0.25,0.5,0.25]
    if nfilt == 5: filt = [0.0625,0.25,0.375,0.25,0.0625]
    return filt[f]
  w = zeros((lev+1,m),Float32)
  cjj = x.astype(Float64)
  for j in range(0,lev):
    cj = zeros((m),Float64)
    if verb: print "Doing levels",j
    ka = arange(m)
    fxa = arange(nfilt)
    def off(fxy,j=j,nfilt=nfilt): return int(pow(2,j)*(fxy-0.5*float(nfilt-1)))
    koffa = []
    cjt = []
    for nf in range(nfilt):
      if periodic: k2 = ka+off(fxa[nf]); koffa.append( k2 - m*greater(k2,m-1))
      else: koffa.append( clip( ka+off(fxa[nf]),0,m-1) )
    for fx in range(nfilt): cjt.append( take(cjj, koffa[fx]) * filter_mask(fx))
    cj = add.reduce(cjt)
    w[j] = (cjj - cj).astype(Float32)
    cjj = 1.0*cj
  w[lev] = cj.astype(Float32)
  return w

def wavefilt1d(x,th,hi=None,noise=None,ttype=atrous1d,nfilt=3,lev=None,nn=2,nt=2,sky=None,gain=1.0,verb=0,test=0,resize=0,per=1):
   if resize:
     osize=len(x)
     nsize = pow(2,int(log2(osize-1))+resize)
     if verb: print "Resizing to",nsize
     ox=1.*x
     x=ones((nsize),ox.typecode()); x[:osize]=ox
     x[osize:(nsize-osize)/2+osize] = (ox[-1] * x[osize:(nsize-osize)/2+osize]).astype(x.typecode())
     x[(nsize-osize)/2+osize:] = (ox[0] * x[(nsize-osize)/2+osize:]).astype(x.typecode())
   lo = th
   if hi == None: hi = lo
   usernoise=0
   if noise:
     if len(shape(usernoise)) > 0:
       usernoise=1
     else:
       noise = gauss(x,noise)
   else: noise=gauss(x,1.0)
   if verb: print "Getting Wavelet Transform of Gaussian Noise",noise.shape
   noise_a = wt1d(noise,ttype,nfilt=nfilt,lev=lev,nn=nn,nt=nt,verb=verb,periodic=per)
   noise_a = noise_a[::,:x.shape[0]]
   if verb: print "Getting Wavelet Transform of Data",x.shape
   x_a = wt1d(x,ttype,nfilt=nfilt,lev=lev,nn=nn,nt=nt,verb=verb,periodic=per)
   x_a = x_a[::,:x.shape[0]]
   if test:
     print len(x_a)
     r = sum(x_a)
   else:
     na = map(lambda n: rms(n), noise_a)
     c = abs(arange(len(x))-len(x)/2.0)
     Jmax = len(x_a)
     J=range(Jmax)
     J.reverse()
     r = x_a[J[0]]
     if verb: print "Optimal reconstruction proceeding"
     for j in J[1:]:
        if verb: print "--> level",j
        u = r*ge(r,0)
        if not usernoise:
          if verb: print "--> computing noise"
          if sky: u = add(u,sky)*ge(sky,0)
          if environ.has_key("gain"): gain = float(environ["gain"])
          n = sqrt(u) * (na[j]/sqrt(gain))
        else:
          n = na[j]
        w = pow(2.0,j)
        e = le(c,w).astype(Float32); e = e/sum(e)
        s = divz(x_a[j],n)
        Klo = lo / w; Khi = hi / w
        m = less(s,Khi)*greater(s,-Klo)
        m = 1.0-m
        if verb: print "--> smoothing mask"
        m = conv1d(m,e,shift=1)
        m = clip(m,0.0,1.0)
        r = r + x_a[j]*m
   if resize: r=1.*r[:osize]
   return r

def wt1d(x,ttype=flwt2d,nfilt=3,lev=None,periodic=None,nn=2,nt=2,verb=0):
   if ttype == atrous1d:
      x_a=atrous1d(x,nfilt=nfilt,lev=lev,periodic=periodic)
   elif ttype == flwt2d:
      m2=2**(max((6,1+int(log2(x.shape[0]-1)))))
      if m2 > len(x):
        if verb: print "--> pasting into",(m2)
        x=paste(x,m2,0)
      if verb: print "--> getting jar",x.shape
      jar = getjar2d(x,nn,nt,noxy=1)
      maxj = max(jar.flat)
      if verb: print "--> undecimating"
      x_a = map(lambda j,x,jar: inverse_flwt2d(flwt2d(x)*equal(jar,j)), range(maxj),maxj*[x],maxj*[jar])
      x_a += [x-sum(x_a)]
      x_a.reverse()
   return squeeze(asarray(x_a))

def wavefilt2d(x,th,noise=None,ttype=flwt2d,nfilt=3,lev=None,nn=2,nt=2,sky=None,gain=1.0,verb=0):
   usernoise=0
   if noise: usernoise=1
   else: noise=gauss(x,1.0)
   if verb: print "Getting Wavelet Transform of Gaussian Noise",noise.shape
   noise_a = wt2d(noise,ttype,nfilt=nfilt,lev=lev,nn=nn,nt=nt,verb=verb)
   if verb: print "Getting Wavelet Transform of Data",x.shape
   x_a = wt2d(x,ttype,nfilt=nfilt,lev=lev,nn=nn,nt=nt,verb=verb)
   na = map(lambda n: rms(n), noise_a)
   ci = indices(x_a[0].shape)
   c = sqrt(power(ci[0]-x_a[0].shape[0]/2.0,2)+power(ci[1]-x_a[0].shape[1]/2.0,2))
   Jmax = len(x_a)
   J=range(Jmax)
   J.reverse()
   r = x_a[J[0]]
   if verb: print "Optimal reconstruction proceeding"
   for j in J[1:]:
      if verb: print "--> level",j
      u = r*ge(r,0)
      if not usernoise:
        if sky: u = add(u,sky)*ge(sky,0)
        if environ.has_key("gain"): gain = float(environ["gain"])
        n = sqrt(u) * (na[j]/sqrt(gain))
      else:
          n = na[j]
      s = power(divz(x_a[j],n),2)
      w = pow(2.0,j)
      e = le(c,w).astype(Float32)
      e = e/sum(e.flat)
      K = th**2 / (w*w)
      m = ge(s,K).astype(Float32)
      if verb: print "--> smoothing mask"
      m = conv2d(m,e,shift=1)
      m = clip(m,0.0,1.0)
      if verb: print "--> adding"
      r = r + x_a[j]*m
   return r[:x.shape[0],:x.shape[1]]

def wt2d(x,ttype=flwt2d,nfilt=3,lev=None,periodic=None,nn=2,nt=2,verb=0):
   s=x.shape
   if ttype == atrous2d:
      x_a=atrous2d(x,nfilt=nfilt,lev=lev,periodic=periodic)
   elif ttype == flwt2d:
      m2=2**(max((6,0+int(log2(x.shape[1]-1))))+1)
      n2=2**(max((6,0+int(log2(x.shape[0]-1))))+1)
      if verb: print "--> pasting into",(n2,m2)
      x=paste(x,m2,n2)
      if verb: print "--> getting jar",x.shape
      jar= getjar2d(x,nn,nt,noxy=1)
      maxj = max(jar.flat)
      if verb: print "--> undecimating"
      x_a= map(lambda j,x,jar: inverse_flwt2d(flwt2d(x)*equal(jar,j)), range(maxj),maxj*[x],maxj*[jar])
      x_a += [x-sum(x_a)]
      x_a.reverse()
   return squeeze(asarray(x_a))[::,:s[0],:s[1]]


